// ==UserScript==
// @name         题库自动化-考试
// @namespace    https://www.lichuanjiu.top/
// @version      3.0.2
// @description  用于题库自动化处理
// @author       李传玖
// @match        https://tiku.kgc.cn/testing/unified/exam

// @icon         https://www.google.com/s2/favicons?sz=64&domain=kgc.cn
// @grant        none
// ==/UserScript==

(function() {
    'use strict';

    //定义用户脚本版本
    var version = "3.0.2";

    //读取用户ID
    var ID = getCookie("tempUserID");
    //判断用户是否激活脚本
    var key = getKey(ID);
    //正确率控制变量
    var wrongTopic;
    if (key != "-1") {
        if(key == "-2"){
            alert("当前脚本已过期，请更新最新可用脚本");
            throw new Error("当前脚本已过期，请更新最新可用脚本");
        }else{

            setCookie("userKey", key);
            var all = null;
            //===========================================================
            //创建dialog对象
            var dialog = document.createElement("dialog");
            //创建style元素
            var style = document.createElement("style");
            dialog.setAttribute("id", "ExaminationDialog");
            dialog.innerHTML = '<div class="input"><h1>欢迎使用题库脚本服务</h1><label for="switch"> 是否获取答案</label><input type="checkbox" name="switch" id="switch" ><label for="accuracy">分数:</label><input type="text" name="accuracy" id="Examinationaccuracy"  value = "100"></div><div class="last"><button  id="ExaminationBtnConfirm">确定</button></div><div class="copy"><span>&copy; <a href="https://itziyuanwang.top" target="_blank">IT资源网产品</a></span> <span><a href="https://www.itziyuanwang.top/supportOur.php" target="_blank">赞助开发</a></span></div>'
            style.innerHTML = '#ExaminationDialog {z-index: 99999; background-color: #fff; border-radius: 10px; box-shadow: 0 0 10px rgba(0, 0, 0, 0.2); position: fixed;top: 50%;transform: translate(0, -50%);padding: 20px;text-align: center;margin: auto;} #ExaminationDialog label {display: block; margin-top: 0.3em;font-weight: bold;} #ExaminationDialog input[type="checkbox"], #ExaminationDialog input[type="text"] {width: 30%; padding: 10px;margin-top: 0.2em; border: 1px solid #ccc;cursor: pointer; border-radius: 5px;}#ExaminationDialog input[type="checkbox"]:focus, #ExaminationDialog input[type="text"]:focus {outline: none;border-color: #007BFF;}#ExaminationDialog button {background-color: #007BFF;color: #fff;padding: 10px 20px; border: none; border-radius: 5px;cursor: pointer; margin-top: 20px;}#ExaminationDialog button:hover {background-color: #005fc4;}#ExaminationDialog button:active {animation: btnactive 0.5s linear reverse;}@keyframes btnactive {0% {background-color: #005fc4;}50% {background-color: #00254d;}100% {background-color: #005fc4;}}#ExaminationDialog .copy {text-align: center;margin-top: 20px; }#ExaminationDialog .copy a {text-decoration: none;color: #007BFF;}#ExaminationDialog .copy a:hover {text-decoration: underline;}';
            //向页面中添加元素
            document.body.append(dialog);
            document.head.append(style);

            document.body.onkeydown = function (e) {
                if (e.ctrlKey && e.altKey && e.code == "KeyJ") {
                    showMain();
                }
            }
            //===================================================================================

        }
    } else {
        alert("抱歉，当前用户尚未激活，无法提供脚本服务！！！");
        throw new Error('用户未激活脚本，无法提供服务！！！');
    }
    function analyzeTheTopic(){
        setTimeout(() => {
            all = document.getElementsByClassName("sec");
            var tempi = 0;
            console.log(all.length);
            var idList = "";
            for (var i = 0; i < all.length; i++) {
                var temppre = all[i].getElementsByTagName("pre");
                var thisze = temppre[0].getElementsByTagName("img");
                if (thisze.length == 1) {
                    console.log(thisze[0].src);
                    var params = queryURLparamsRegEs5(thisze[0].src)["relativePath"];
                    var encryptionId = getID(params);//到这里我们获取到了题目的加密ID

                    //获取用户ID
                    var tempUserID = getCookie("tempUserID");

                    //获取真实ID
                    var realID = getID(encryptionId) + "/" + (getIDNum(encryptionId) - tempUserID);

                    idList = idList + realID + ";";
                    console.log(idList);
                }
            }
            operation(idList, getCookie("tempUserID"));
        }, 2000);
    }
    function operation(idList, key) {

        var data = new FormData();
        data.append("id", idList);
        data.append("key", key);

        //创建异步对象
        var xhr = new XMLHttpRequest();
        //设置请求的类型及url
        xhr.open('post', 'https://kgc.tiku.lichuanjiu.top/api/tiku/getAnswers.php');
        //post请求一定要添加请求头才行不然会报错
        // xhr.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
        //发送请求
        xhr.send(data);
        xhr.onreadystatechange = function () {
            // 这步为判断服务器是否正确响应
            if (xhr.readyState == 4 && xhr.status == 200) {
                //拿到服务器的数据,并解析
                var result = parseData(xhr.responseText);
                //填写数据到页面
                fillIn(result);
                console.log(result);
            }
        };
    }

    // https://tiku.kgc.cn/testing/cdn/getImage?relativePath=0012000/1543303458188/616904c46eec36797abd9929c5dd34bf.jpg&imageType=2
    //获得参数
    function queryURLparamsRegEs5(url) {
        let obj = {}
        let reg = /([^?=&]+)=([^?=&]+)/g
        url.replace(reg, function () {
            obj[arguments[1]] = arguments[2]
        })
        return obj
    }
    function getID(parameter) {
        var index = parameter.lastIndexOf("/");
        var ID = parameter.substr(0, index);
        return ID;
    }
    function getIDNum(encryptionId) {
        var index = encryptionId.lastIndexOf("/");
        var IDNum = encryptionId.substr(index + 1, encryptionId.length);
        return IDNum;
    }
    //解析来自后台的数据
    function parseData(data) {
        //去除data中最后一个“;”
        var index = data.lastIndexOf(";");
        data = data.substr(0, index);
        var pData = data.split(";");
        return pData;
    }
    //将参数填写到页面
    function fillIn(parameter) {
        var arr = ["A", "B", "C", "D", "E"];
        for (var i = 0; i < parameter.length; i++) {
            //判断题目是否在数据库中记录
            if (parameter[i] != -1) {
                var listOfOptions = all[i].getElementsByTagName("input");
                //判断题目是多选还是单选
                if (parameter[i].length > 2) {//这是一道多选题
                    var multipleSelectionList = parameter[i].split(",");
                    multipleSelectionList.forEach(element => {
                        var index = arr.map(item => item).indexOf(element);
                        // listOfOptions[index].style="width: 20px;height: 20px;";
                        var parentNode = listOfOptions[index].parentNode.getElementsByTagName("a")[0];
                        parentNode.style.cursor = "help";
                        listOfOptions[index].click();

                    });
                } else {//单选题

                    var index = arr.map(item => item).indexOf(parameter[i]);
                    //listOfOptions[index].style="width: 20px;height: 20px;";
                    var parentNode = listOfOptions[index].parentNode.getElementsByTagName("a")[0];
                    parentNode.style.cursor = "help";

                    //扰动正确答案，达到控制正确率的效果
                    if(wrongTopic > 0){
                        if(index == 0){
                            index = 3;
                        }else{
                            index --;
                        }
                        wrongTopic--;
                    }
                    listOfOptions[index].click();

                    console.log(index)

                }

            }
        }
    }
    function setCookie(c_name, value, expiredays) {
        var exdate = new Date();
        exdate.setDate(exdate.getDate() + expiredays);
        document.cookie = c_name + "=" + escape(value) +
            ((expiredays == null) ? "" : ";expires=" + exdate.toGMTString()) + ";path=/";
    }
    function getCookie(name) {
        var cookies = document.cookie;
        var list = cookies.split("; "); // 解析出名/值对列表

        for (var i = 0; i < list.length; i++) {
            var arr = list[i].split("="); // 解析出名和值
            if (arr[0] == name) {
                return decodeURIComponent(arr[1]); // 对cookie值解码
            }
        }
        return "";
    }
    function getKey(userID) {
        //创建提交数据，在其中添加数据
        var data = new FormData();
        data.append("id",userID);
        data.append("version",version);

        //创建异步对象
        var xhr = new XMLHttpRequest();
        xhr.open("post","https://kgc.tiku.lichuanjiu.top/api/tiku/getKey.php",false);
        //发送请求数据
        xhr.send(data);
        if(xhr.status == 200){
            return xhr.responseText;
        }
    }
    //计算正确率
    function calculationAccuracy(accuracy){
        all = document.getElementsByClassName("sec");
        //计算应该错误和正确的题量
        wrongTopic = parseInt(all.length - ((accuracy/100)*all.length));
    }
    function showMain() {
        if (dialog.open) {
            return;
        }
        dialog.showModal();
        document.getElementById("ExaminationBtnConfirm").onclick = btnConfirm;
        document.getElementById("Examinationaccuracy").oninput = function(){
            inputCheck(this);
        };
    }
    function btnConfirm() {
        //获取元素选择框
        let checkbox = document.getElementById("switch").checked;
        let accuracy = document.getElementById("Examinationaccuracy").value;
        if( isNaN(accuracy) || accuracy > 100 || accuracy < 1){
            accuracy=100;
        }
        if(checkbox){
            calculationAccuracy(accuracy);
            analyzeTheTopic();
        }
        //关闭dialog
        dialog.close();
    }
    function inputCheck(element) {
        element.value = element.value.replace(/[^\d]/g, '');
        if (element.value > 100) {
            element.value = 100;
            return;
        }
        if (element.value < 1 && element.value != "") {
            element.value = 1;
        }
    }
})();